// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from foros_msgs:srv/AppendEntries.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_H_
#define FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'entries'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in srv/AppendEntries in the package foros_msgs.
typedef struct foros_msgs__srv__AppendEntries_Request
{
  /// leader's term
  uint64_t term;
  /// so followers can redirect clients
  uint32_t leader_id;
  /// index of log entry immediately preceeding new ones
  uint64_t prev_log_index;
  /// term of prev_log_index
  uint64_t prev_log_term;
  /// log entries to store (empty for heartbeat)
  rosidl_runtime_c__octet__Sequence entries;
  /// leader's commitIndex
  uint64_t leader_commit;
} foros_msgs__srv__AppendEntries_Request;

// Struct for a sequence of foros_msgs__srv__AppendEntries_Request.
typedef struct foros_msgs__srv__AppendEntries_Request__Sequence
{
  foros_msgs__srv__AppendEntries_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} foros_msgs__srv__AppendEntries_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/AppendEntries in the package foros_msgs.
typedef struct foros_msgs__srv__AppendEntries_Response
{
  /// current term, for leader to update itself
  uint64_t term;
  /// true if follower contained entry matching
  /// prev_data_index and prev_data_term
  bool success;
} foros_msgs__srv__AppendEntries_Response;

// Struct for a sequence of foros_msgs__srv__AppendEntries_Response.
typedef struct foros_msgs__srv__AppendEntries_Response__Sequence
{
  foros_msgs__srv__AppendEntries_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} foros_msgs__srv__AppendEntries_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__STRUCT_H_
