// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from foros_msgs:srv/RequestVote.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_HPP_
#define FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__foros_msgs__srv__RequestVote_Request __attribute__((deprecated))
#else
# define DEPRECATED__foros_msgs__srv__RequestVote_Request __declspec(deprecated)
#endif

namespace foros_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RequestVote_Request_
{
  using Type = RequestVote_Request_<ContainerAllocator>;

  explicit RequestVote_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->candidate_id = 0ul;
      this->last_data_index = 0ull;
      this->loat_data_term = 0ull;
    }
  }

  explicit RequestVote_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->candidate_id = 0ul;
      this->last_data_index = 0ull;
      this->loat_data_term = 0ull;
    }
  }

  // field types and members
  using _term_type =
    uint64_t;
  _term_type term;
  using _candidate_id_type =
    uint32_t;
  _candidate_id_type candidate_id;
  using _last_data_index_type =
    uint64_t;
  _last_data_index_type last_data_index;
  using _loat_data_term_type =
    uint64_t;
  _loat_data_term_type loat_data_term;

  // setters for named parameter idiom
  Type & set__term(
    const uint64_t & _arg)
  {
    this->term = _arg;
    return *this;
  }
  Type & set__candidate_id(
    const uint32_t & _arg)
  {
    this->candidate_id = _arg;
    return *this;
  }
  Type & set__last_data_index(
    const uint64_t & _arg)
  {
    this->last_data_index = _arg;
    return *this;
  }
  Type & set__loat_data_term(
    const uint64_t & _arg)
  {
    this->loat_data_term = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    foros_msgs::srv::RequestVote_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const foros_msgs::srv::RequestVote_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::RequestVote_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::RequestVote_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__foros_msgs__srv__RequestVote_Request
    std::shared_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__foros_msgs__srv__RequestVote_Request
    std::shared_ptr<foros_msgs::srv::RequestVote_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RequestVote_Request_ & other) const
  {
    if (this->term != other.term) {
      return false;
    }
    if (this->candidate_id != other.candidate_id) {
      return false;
    }
    if (this->last_data_index != other.last_data_index) {
      return false;
    }
    if (this->loat_data_term != other.loat_data_term) {
      return false;
    }
    return true;
  }
  bool operator!=(const RequestVote_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RequestVote_Request_

// alias to use template instance with default allocator
using RequestVote_Request =
  foros_msgs::srv::RequestVote_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace foros_msgs


#ifndef _WIN32
# define DEPRECATED__foros_msgs__srv__RequestVote_Response __attribute__((deprecated))
#else
# define DEPRECATED__foros_msgs__srv__RequestVote_Response __declspec(deprecated)
#endif

namespace foros_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct RequestVote_Response_
{
  using Type = RequestVote_Response_<ContainerAllocator>;

  explicit RequestVote_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->vote_granted = false;
    }
  }

  explicit RequestVote_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->term = 0ull;
      this->vote_granted = false;
    }
  }

  // field types and members
  using _term_type =
    uint64_t;
  _term_type term;
  using _vote_granted_type =
    bool;
  _vote_granted_type vote_granted;

  // setters for named parameter idiom
  Type & set__term(
    const uint64_t & _arg)
  {
    this->term = _arg;
    return *this;
  }
  Type & set__vote_granted(
    const bool & _arg)
  {
    this->vote_granted = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    foros_msgs::srv::RequestVote_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const foros_msgs::srv::RequestVote_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::RequestVote_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      foros_msgs::srv::RequestVote_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__foros_msgs__srv__RequestVote_Response
    std::shared_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__foros_msgs__srv__RequestVote_Response
    std::shared_ptr<foros_msgs::srv::RequestVote_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RequestVote_Response_ & other) const
  {
    if (this->term != other.term) {
      return false;
    }
    if (this->vote_granted != other.vote_granted) {
      return false;
    }
    return true;
  }
  bool operator!=(const RequestVote_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RequestVote_Response_

// alias to use template instance with default allocator
using RequestVote_Response =
  foros_msgs::srv::RequestVote_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace foros_msgs

namespace foros_msgs
{

namespace srv
{

struct RequestVote
{
  using Request = foros_msgs::srv::RequestVote_Request;
  using Response = foros_msgs::srv::RequestVote_Response;
};

}  // namespace srv

}  // namespace foros_msgs

#endif  // FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__STRUCT_HPP_
