// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from foros_msgs:msg/Inspector.idl
// generated code does not contain a copyright notice
#include "foros_msgs/msg/detail/inspector__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `cluster_name`
#include "rosidl_runtime_c/string_functions.h"

bool
foros_msgs__msg__Inspector__init(foros_msgs__msg__Inspector * msg)
{
  if (!msg) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__init(&msg->stamp)) {
    foros_msgs__msg__Inspector__fini(msg);
    return false;
  }
  // cluster_name
  if (!rosidl_runtime_c__String__init(&msg->cluster_name)) {
    foros_msgs__msg__Inspector__fini(msg);
    return false;
  }
  // cluster_size
  // id
  // state
  // term
  // data_size
  // voted_for
  return true;
}

void
foros_msgs__msg__Inspector__fini(foros_msgs__msg__Inspector * msg)
{
  if (!msg) {
    return;
  }
  // stamp
  builtin_interfaces__msg__Time__fini(&msg->stamp);
  // cluster_name
  rosidl_runtime_c__String__fini(&msg->cluster_name);
  // cluster_size
  // id
  // state
  // term
  // data_size
  // voted_for
}

bool
foros_msgs__msg__Inspector__are_equal(const foros_msgs__msg__Inspector * lhs, const foros_msgs__msg__Inspector * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->stamp), &(rhs->stamp)))
  {
    return false;
  }
  // cluster_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->cluster_name), &(rhs->cluster_name)))
  {
    return false;
  }
  // cluster_size
  if (lhs->cluster_size != rhs->cluster_size) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // state
  if (lhs->state != rhs->state) {
    return false;
  }
  // term
  if (lhs->term != rhs->term) {
    return false;
  }
  // data_size
  if (lhs->data_size != rhs->data_size) {
    return false;
  }
  // voted_for
  if (lhs->voted_for != rhs->voted_for) {
    return false;
  }
  return true;
}

bool
foros_msgs__msg__Inspector__copy(
  const foros_msgs__msg__Inspector * input,
  foros_msgs__msg__Inspector * output)
{
  if (!input || !output) {
    return false;
  }
  // stamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->stamp), &(output->stamp)))
  {
    return false;
  }
  // cluster_name
  if (!rosidl_runtime_c__String__copy(
      &(input->cluster_name), &(output->cluster_name)))
  {
    return false;
  }
  // cluster_size
  output->cluster_size = input->cluster_size;
  // id
  output->id = input->id;
  // state
  output->state = input->state;
  // term
  output->term = input->term;
  // data_size
  output->data_size = input->data_size;
  // voted_for
  output->voted_for = input->voted_for;
  return true;
}

foros_msgs__msg__Inspector *
foros_msgs__msg__Inspector__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__msg__Inspector * msg = (foros_msgs__msg__Inspector *)allocator.allocate(sizeof(foros_msgs__msg__Inspector), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(foros_msgs__msg__Inspector));
  bool success = foros_msgs__msg__Inspector__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
foros_msgs__msg__Inspector__destroy(foros_msgs__msg__Inspector * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    foros_msgs__msg__Inspector__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
foros_msgs__msg__Inspector__Sequence__init(foros_msgs__msg__Inspector__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__msg__Inspector * data = NULL;

  if (size) {
    data = (foros_msgs__msg__Inspector *)allocator.zero_allocate(size, sizeof(foros_msgs__msg__Inspector), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = foros_msgs__msg__Inspector__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        foros_msgs__msg__Inspector__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
foros_msgs__msg__Inspector__Sequence__fini(foros_msgs__msg__Inspector__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      foros_msgs__msg__Inspector__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

foros_msgs__msg__Inspector__Sequence *
foros_msgs__msg__Inspector__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  foros_msgs__msg__Inspector__Sequence * array = (foros_msgs__msg__Inspector__Sequence *)allocator.allocate(sizeof(foros_msgs__msg__Inspector__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = foros_msgs__msg__Inspector__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
foros_msgs__msg__Inspector__Sequence__destroy(foros_msgs__msg__Inspector__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    foros_msgs__msg__Inspector__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
foros_msgs__msg__Inspector__Sequence__are_equal(const foros_msgs__msg__Inspector__Sequence * lhs, const foros_msgs__msg__Inspector__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!foros_msgs__msg__Inspector__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
foros_msgs__msg__Inspector__Sequence__copy(
  const foros_msgs__msg__Inspector__Sequence * input,
  foros_msgs__msg__Inspector__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(foros_msgs__msg__Inspector);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    foros_msgs__msg__Inspector * data =
      (foros_msgs__msg__Inspector *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!foros_msgs__msg__Inspector__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          foros_msgs__msg__Inspector__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!foros_msgs__msg__Inspector__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
