// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from foros_msgs:msg/Inspector.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__MSG__DETAIL__INSPECTOR__TRAITS_HPP_
#define FOROS_MSGS__MSG__DETAIL__INSPECTOR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "foros_msgs/msg/detail/inspector__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace foros_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Inspector & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: cluster_name
  {
    out << "cluster_name: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_name, out);
    out << ", ";
  }

  // member: cluster_size
  {
    out << "cluster_size: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_size, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: state
  {
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << ", ";
  }

  // member: term
  {
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << ", ";
  }

  // member: data_size
  {
    out << "data_size: ";
    rosidl_generator_traits::value_to_yaml(msg.data_size, out);
    out << ", ";
  }

  // member: voted_for
  {
    out << "voted_for: ";
    rosidl_generator_traits::value_to_yaml(msg.voted_for, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Inspector & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: cluster_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_name: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_name, out);
    out << "\n";
  }

  // member: cluster_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cluster_size: ";
    rosidl_generator_traits::value_to_yaml(msg.cluster_size, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state: ";
    rosidl_generator_traits::value_to_yaml(msg.state, out);
    out << "\n";
  }

  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: data_size
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data_size: ";
    rosidl_generator_traits::value_to_yaml(msg.data_size, out);
    out << "\n";
  }

  // member: voted_for
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "voted_for: ";
    rosidl_generator_traits::value_to_yaml(msg.voted_for, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Inspector & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace foros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use foros_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const foros_msgs::msg::Inspector & msg,
  std::ostream & out, size_t indentation = 0)
{
  foros_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use foros_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const foros_msgs::msg::Inspector & msg)
{
  return foros_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<foros_msgs::msg::Inspector>()
{
  return "foros_msgs::msg::Inspector";
}

template<>
inline const char * name<foros_msgs::msg::Inspector>()
{
  return "foros_msgs/msg/Inspector";
}

template<>
struct has_fixed_size<foros_msgs::msg::Inspector>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<foros_msgs::msg::Inspector>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<foros_msgs::msg::Inspector>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // FOROS_MSGS__MSG__DETAIL__INSPECTOR__TRAITS_HPP_
