// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from foros_msgs:srv/AppendEntries.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_
#define FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "foros_msgs/srv/detail/append_entries__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace foros_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const AppendEntries_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: term
  {
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << ", ";
  }

  // member: leader_id
  {
    out << "leader_id: ";
    rosidl_generator_traits::value_to_yaml(msg.leader_id, out);
    out << ", ";
  }

  // member: prev_log_index
  {
    out << "prev_log_index: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_log_index, out);
    out << ", ";
  }

  // member: prev_log_term
  {
    out << "prev_log_term: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_log_term, out);
    out << ", ";
  }

  // member: entries
  {
    if (msg.entries.size() == 0) {
      out << "entries: []";
    } else {
      out << "entries: [";
      size_t pending_items = msg.entries.size();
      for (auto item : msg.entries) {
        rosidl_generator_traits::character_value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: leader_commit
  {
    out << "leader_commit: ";
    rosidl_generator_traits::value_to_yaml(msg.leader_commit, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AppendEntries_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: leader_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "leader_id: ";
    rosidl_generator_traits::value_to_yaml(msg.leader_id, out);
    out << "\n";
  }

  // member: prev_log_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prev_log_index: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_log_index, out);
    out << "\n";
  }

  // member: prev_log_term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "prev_log_term: ";
    rosidl_generator_traits::value_to_yaml(msg.prev_log_term, out);
    out << "\n";
  }

  // member: entries
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.entries.size() == 0) {
      out << "entries: []\n";
    } else {
      out << "entries:\n";
      for (auto item : msg.entries) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::character_value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: leader_commit
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "leader_commit: ";
    rosidl_generator_traits::value_to_yaml(msg.leader_commit, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AppendEntries_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace foros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use foros_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const foros_msgs::srv::AppendEntries_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  foros_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use foros_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const foros_msgs::srv::AppendEntries_Request & msg)
{
  return foros_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries_Request>()
{
  return "foros_msgs::srv::AppendEntries_Request";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries_Request>()
{
  return "foros_msgs/srv/AppendEntries_Request";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<foros_msgs::srv::AppendEntries_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace foros_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const AppendEntries_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: term
  {
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << ", ";
  }

  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AppendEntries_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AppendEntries_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace foros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use foros_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const foros_msgs::srv::AppendEntries_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  foros_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use foros_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const foros_msgs::srv::AppendEntries_Response & msg)
{
  return foros_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries_Response>()
{
  return "foros_msgs::srv::AppendEntries_Response";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries_Response>()
{
  return "foros_msgs/srv/AppendEntries_Response";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<foros_msgs::srv::AppendEntries_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<foros_msgs::srv::AppendEntries>()
{
  return "foros_msgs::srv::AppendEntries";
}

template<>
inline const char * name<foros_msgs::srv::AppendEntries>()
{
  return "foros_msgs/srv/AppendEntries";
}

template<>
struct has_fixed_size<foros_msgs::srv::AppendEntries>
  : std::integral_constant<
    bool,
    has_fixed_size<foros_msgs::srv::AppendEntries_Request>::value &&
    has_fixed_size<foros_msgs::srv::AppendEntries_Response>::value
  >
{
};

template<>
struct has_bounded_size<foros_msgs::srv::AppendEntries>
  : std::integral_constant<
    bool,
    has_bounded_size<foros_msgs::srv::AppendEntries_Request>::value &&
    has_bounded_size<foros_msgs::srv::AppendEntries_Response>::value
  >
{
};

template<>
struct is_service<foros_msgs::srv::AppendEntries>
  : std::true_type
{
};

template<>
struct is_service_request<foros_msgs::srv::AppendEntries_Request>
  : std::true_type
{
};

template<>
struct is_service_response<foros_msgs::srv::AppendEntries_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // FOROS_MSGS__SRV__DETAIL__APPEND_ENTRIES__TRAITS_HPP_
